PROGRAM RedOrBlack ;

USES DOS, CRT, jpglobal, ansiunit, JPDoor41, StrSup ;

CONST
   Version  = '2.FW' ;
   BlackRow = 8 ;         { black hand's screen row number }
   RedRow   = 13 ;        { red hand's screen row number   }
                          { card column numbers:           }
   CardCol  : ARRAY [1..20] OF BYTE = (16,18,21,24,27,30,33,36,39,42,
                                       45,48,51,54,57,60,63,66,69,72) ;

TYPE
   DeckRec  = RECORD
                 CardNum : STR2 ;
                 Suit    : CardSuit ;
              END ;

  JulRecord = Record
                LastRecordedDate : Real ;
              End ;


VAR
   yr,mn,dt,dy   : WORD ;
   CardDeck      : ARRAY [1..312] OF DeckRec ;
   Card          : DeckRec ;
   FirstCard     : DeckRec ;
   Graphics,
   Holding       : CHAR ;
   TurnCount     : INTEGER ;
   MaxTurns      : INTEGER ;
   Code          : INTEGER ;
   AbortGame,
   Won,
   FirstPlay     : BOOLEAN ;
   InfoPath,
   ConfigName,
   RatPath,
   AdoptedBy     : STRING ;
   GameClosed    : BOOLEAN ;
   MaxBet        : INTEGER ;
   BetAmount     : INTEGER ;
   BetType       : CHAR ;
   CardCounter,
   RedScore,
   BlackScore,
   BlackCounter,
   RedCounter    : INTEGER ;
   BlackDiff,
   RedDiff       : INTEGER ;
   DSpeed        : INTEGER ;
   LoopVar       : INTEGER ;
   StartTime,
   Coins,
   CoinValue,
   MaxWinnings,
   ETime,
   STime,
   TimePlayed,
   Difference,
   Winnings,
   EndCoins,
   StartCoins    : INTEGER ;


{$F+}
PROCEDURE ALT_C ;
BEGIN
   WRITELN('ALT-C') ;
END ;
{$F-}

PROCEDURE PollTerm ;
VAR
   timeout    : INTEGER ;
   Seconds    : INTEGER ;
   hr,mn,s,d  : WORD ;
   ACKStr     : STRING ;
   chx        : CHAR ;
BEGIN
   IF Local THEN BEGIN
      RIP := FALSE ;
      Exit ;
   END ;
   sDisplay(0,0,0,' ') ;
   sDisplay(0,0,0,#27+'[!') ;
   Timeout := 0 ;
   Seconds := 0 ;
   ACKStr := '' ;
   REPEAT
      GetTime(hr,mn,s,d) ;
      IF Seconds <> s THEN BEGIN
         INC(Timeout) ;
         Seconds := s ;
      END ;
      IF InReady THEN ACKstr := ACKStr + GetChar ;
   UNTIL (LENGTH(ACKStr) > 8) OR (Timeout > 3) ;
   IF POS('RIPSCRIP',ACKStr) > 0 THEN BEGIN
      RIP := TRUE ;
      if inready then begin
         repeat
            chx := getchar ;
         until not inready ;
      end ;
      Exit ;
   END ELSE BEGIN
      RIP := FALSE ;
      Exit ;
   END ;
END ;

PROCEDURE SendOut(disp:textstring) ;
var
   k   : byte ;
begin
   if local then exit ;
   chkconnect ;
   for k := 1 to Length(disp) do CharOut(disp[k]) ;
   CharOut(#13) ;
   CharOut(#10) ;
   chkconnect ;
end ;



FUNCTION Julian( year : integer; mon, day : byte): real;
VAR
  temp        : real;
BEGIN                                      { function Julian                 }
  if (year < 0) OR (mon < 1) OR (day < 1) OR (day > 31) then
    begin
      Julian := -1;
      exit;
    end;  { IF }
  if year < 100 then
    year := year + 1900;
  temp := int((mon - 14.0) / 12.0);
  Julian := day - 32075.0 +
            int(1461.0 * (year + 4800.0 + temp) / 4.0) +
            int(367.0 * (mon - 2.0 - temp * 12.0) / 12.0) -
            int(3.0 * int((year + 4900.0 + temp) / 100.0) / 4.0)
END ;



PROCEDURE JPDelay(n:INTEGER ; KeyGet,EatChar : BOOLEAN) ;
VAR
   hr,mn,sec,sec100    : WORD ;
   loopvar             : INTEGER ;
   counter             : INTEGER ;
BEGIN
   GetTime(hr,mn,sec,sec100) ;
   loopvar := sec ;
   counter := 0 ;
   REPEAT
      GetTime(hr,mn,sec,sec100) ;
      IF sec <> loopvar THEN BEGIN
         loopvar := sec ;
         INC(counter) ;
      END ;
      IF KeyGet THEN BEGIN
         IF (NOT Local) AND (InReady) THEN BEGIN
            IF EatChar THEN holding := GetChar ;
            counter := n + 1 ;
         END ELSE IF KeyPressed THEN BEGIN
            IF EatChar THEN holding := READKEY ;
            counter := n + 1 ;
         END ;
      END ;
   UNTIL counter >= n ;
END ;


FUNCTION AtoI(Tstr:STRING) : LONGINT ;
VAR
   num        : LONGINT ;
   code       : INTEGER ;
BEGIN
   VAL(Tstr,num,code) ;
   IF code <> 0 THEN BEGIN
      AtoI := 0 ;
      EXIT ;
   END ELSE BEGIN
      AtoI := num ;
      EXIT ;
   END ;
END ;


PROCEDURE GetParms ;
BEGIN
   IF PARAMCOUNT = 0 THEN ConfigName := 'ROB.CFG'
      ELSE ConfigName := ChangeCase(ParamStr(1)) ;
END ;


PROCEDURE GetConfig ;
VAR
   ConfigFile    : TEXT ;
   Line          : STRING ;
   num,code      : INTEGER ;
BEGIN
   writeln('start getconfig') ;
   MaxWinnings := 500 ;
   MaxTurns := 100 ;
   MaxBet := 5 ;
   CoinValue := 2 ;
   IF NOT EXIST(ConfigName) THEN BEGIN
      WRITELN(#7,' Serious error: Cannot open configuration file: ',ConfigName) ;
      HALT(15) ;
   END ;
   ASSIGN(ConfigFile,ConfigName) ;
   RESET(ConfigFile) ;
   READLN(ConfigFile,Line) ; { path to exitinfo.bbs and dorinfo1.def }
   IF Line[LENGTH(line)] <> '\' THEN InfoPath := Line + '\'
     ELSE InfoPath := Line ;
   READLN(ConfigFile,Line) ; { path to RATS.EXE }
   IF Line[Length(line)] <> '\' THEN RatPath := Line + '\'
     ELSE RatPath := Line ;
   READLN(ConfigFile,Line) ; { get the node number in use but don't use it }
   READLN(ConfigFile,Line) ; { get coin value             }
   VAL(Line,num,code) ;
   IF (num<1) OR (num>10) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Coin value error, using default of 2') ;
   END ELSE CoinValue := num ;
   READLN(ConfigFile,Line) ; { get maximum bet - max coins }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Max bet error, using default of 5 coins') ;
   END ELSE MaxBet := num ;
   READLN(ConfigFile,Line) ; { get maximum turns }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Max turns error, using default of 100') ;
   END ELSE MaxTurns := num ;
   READLN(ConfigFile,Line) ;  { get max winnings }
   VAL(line,num,code) ;
   IF (num<1) OR (num>32000) OR (code<>0) THEN BEGIN
      WRITELN(' Error: Max winnings error, using default of 500') ;
   END ELSE MaxWinnings := num ;
   CLOSE(ConfigFile) ;
   writeln('end getconfig') ;
END ;


PROCEDURE RecordTurns ;
VAR
  TextFile      : Text ;
  NewFile       : Text ;
  Located       : Boolean ;
  NameStr       : String[35] ;
  Line          : String ;
BEGIN
  Assign(TextFile,'ROB.TRN') ;
  {$I-} Reset(TextFile) ; {$I+}
  if ioresult <> 0 then begin
    Rewrite(TextFile) ;
    writeln(TextFile,UserName+':'+itoa(turncount)) ;
    close(TextFile) ;
    Exit ;
  end else begin
    assign(NewFile,'ROBTURN.$$$') ;
    Rewrite(NewFile) ;
    while not eof(TextFile) do begin
      readln(TextFile,line) ;
      NameStr := copy(line,1,pos(':',line)-1) ;
      if NameStr <> UserName then writeln(NewFile,line) ;
    end ;
    flush(newfile) ;
    close(TextFile) ;
    close(NewFile) ;
    erase(TextFile) ;
    rename(NewFile,'ROB.TRN') ;
    Append(TextFile) ;
    writeln(TextFile,UserName+':'+itoa(TurnCount)) ;
    flush(textfile) ;
    Close(TextFile) ;
  end ;
End ;



Procedure GetTurns ;
Var
  TextFile    : Text ;
  NameStr     : String[35] ;
  code        : INTEGER ;
  line        : STRING ;
Begin
  if not exist('ROB.TRN') then exit ;
  Assign(TextFile,'ROB.TRN') ;
  Reset(TextFile) ;
  While not eof(TextFile) do begin
    readln(TextFile,line) ;
    NameStr := copy(line,1,pos(':',line)-1) ;
    if NameStr = UserName then begin
      Val(copy(line,pos(':',line)+1,4),TurnCount,code) ;
    end ;
  end ;
  CLOSE(TextFile) ;
End ;


PROCEDURE AdjustLog ;
Var
  LogFile    : Text ;
  LogCount   : Byte ;
  LogLine    : Array [1..10] of TextString ;
  i          : INTEGER ;
Begin
  if not exist('ROB.HST') then exit ;
  LogCount := 0 ;
  Assign(LogFile,'ROB.HST') ;
  Reset(LogFile) ;
  while not eof(LogFile) do begin
    LogCount := LogCount + 1 ;
    readln(LogFile,LogLine[LogCount]) ;
  end ;
  Close(LogFile) ;
  If LogCount = 0 then exit ;
  if LogCount >= 5 then begin
    Rewrite(LogFile) ;
    for i := 2 to 5 do writeln(LogFile,LogLine[i]) ;
    Flush(LogFile) ;
    Close(LogFile) ;
  end ;
End ;



PROCEDURE WriteLog(PlayerWon:BOOLEAN;HowMuch:INTEGER) ;
VAR
   y,m,dt,dy   : WORD ;
   Logfile     : TEXT ;
   ss          : STRING[8] ;
BEGIN
   AdjustLog ;
   IF ((PlayerWon) AND (HowMuch > 0)) THEN ss := ' won ' ELSE ss := ' lost ' ;
   GetDate(y,m,dt,dy) ;
   ASSIGN(Logfile,'ROB.HST') ;
   IF EXIST('ROB.HST') THEN APPEND(Logfile) ELSE REWRITE(Logfile) ;
   WRITELN(Logfile,FormatStr(UserName) + ss + StrC(HowMuch) + ' minutes') ;
   FLUSH(Logfile) ;
   CLOSE(Logfile) ;
END ;



PROCEDURE CloseGame ;
BEGIN
   ClearScreen ;
   IF NOT GameClosed THEN BEGIN
      RecordTurns ;
      EndCoins := Coins ;
      ETime := EndCoins * CoinValue ;
      STime := StartCoins * CoinValue ;
      TimePlayed := StartTime - TimeRemaining ;
      IF ETime > STime THEN BEGIN
         Difference := ETime - STime ;
         Won := TRUE ;
         Winnings := Difference - TimePlayed ;
         IncTime(Difference) ;
         WriteLog(TRUE,Winnings) ;
      END ELSE BEGIN
         Difference := STime - ETime ;
         Won := FALSE ;
         Winnings := Difference + TimePlayed ;
         DecTime(Difference) ;
         WriteLog(FALSE,Winnings) ;
      END ;
   END ;
END ;


PROCEDURE TinyFlag ;
BEGIN
   sDisplay(0,15,0,'This software was made in a small computer room in the USA ') ;
   sDisplay(1,15,0,'**') ;
   sDisplay(4,15,0,'') ;
   Display(0,15,0,' ') ;
END ;


PROCEDURE LastComments ;
BEGIN
   TinyFlag ;
   CRLF ;
   sDisplay(0,14,0,'Closing ') ;
   sDisplay(0,12,0,'Red Or Black For Time ') ;
   sDisplay(0,14,0,'and returning to ') ;
   sDisplay(0,11,0,FormatStr(SystemName)) ;
   Display(0,14,0,'...') ;
   CRLF ;
   Display(0,7,0,'One moment...') ;
   CRLF ;
END ;

PROCEDURE Comments ;
VAR
   ss      : STRING ;
   Deposit : INTEGER ;
   te      : INTEGER ;
BEGIN
   GameClosed := TRUE ;
   SetColor(0,7,0) ; sDisplay(0,7,0,' ') ;
   ClearScreen ;
   IF Won THEN ShowFile(0,0,0,'YOUWON','')
      ELSE ShowFile(0,0,0,'YOULOST','') ;
   CRLF ;
   Display(0,15,0,'Here''s what you looked like on the house monitors:') ;
   Display(0,13,0,'') ;
   sDisplay(0,11,0,'Time you came in with: ') ;
   Display(0,15,0,itoa(STime)) ;
   sDisplay(0,11,0,'Time you ended with:   ') ;
   Display(0,15,0,itoa(ETime)) ;
   IF Won THEN BEGIN
      sDisplay(0,11,0,'Time you won:          ') ;
      Display(0,15,0,itoa(Difference)) ;
      sDisplay(0,11,0,'Time spent playing:   -') ;
      Display(0,15,0,itoa(TimePlayed)) ;
      sDisplay(0,11,0,'Total winnings:        ') ;
      Display(0,15,0,itoa(Winnings)) ;
   END ELSE BEGIN
      sDisplay(0,11,0,'Time you lost:         ') ;
      Display(0,15,0,itoa(Difference)) ;
      sDisplay(0,11,0,'Time spent playing:   -') ;
      Display(0,15,0,itoa(TimePlayed)) ;
      sDisplay(0,11,0,'Total losses:          ') ;
      Display(0,15,0,itoa(Winnings)) ;
   END ;
   sDisplay(0,11,0,'Adjusted time limit:   ') ;
   Display(0,15,0,itoa(TimeRemaining)) ;
   Display(0,13,0,'') ;
   CRLF ;
   More('Press [any key] to continue',14) ;
   te := TimeToEvent ;
   IF TimeRemaining > TimeToEvent THEN BEGIN
      ClearScreen ;
      sDisplay(0,15,0,'There is a ') ;
      sDisplay(0,15,1,'SYSTEM EVENT') ;
      sDisplay(0,15,0,' in ') ;
      STR(TimeToEvent,ss) ;
      sDisplay(0,15,1,ss) ;
      Display(0,15,0,' minutes:') ;
      Display(0,13,0,'') ;
      sDisplay(0,14,0,'Your time remaining.................................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      sDisplay(0,14,0,'Time to system event................................. ') ;
      Display(0,15,0,Stri(TimeToEvent,4)) ;
      sDisplay(0,14,0,'Time automatically deposited into your bank account.. ') ;
      Deposit := TimeRemaining - TimeToEvent ;
      Display(0,15,0,Stri(Deposit,4)) ;
      DepositTime(RatPath,UserName,Deposit) ;
      DecTime(Deposit) ;
      sDisplay(0,14,0,'Your adjusted time limit............................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      CRLF ;
      More('Press [any key] to continue',12) ;
   END ;
   IF (TimeRemaining > MaxWinnings) AND (UserName <> SysopName) THEN
   BEGIN
      ClearScreen ;
      sDisplay(0,15,0,'You have exceeded the maximum allowed winnings of ') ;
      STR(MaxWinnings,ss) ;
      sDisplay(0,15,1,ss) ;
      Display(0,15,0,' minutes:') ;
      Display(0,13,0,'') ;
      sDisplay(0,14,0,'Your time remaining.................................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      sDisplay(0,14,0,'Maximum winnings allowed............................. ') ;
      Display(0,15,0,Stri(MaxWinnings,4)) ;
      sDisplay(0,14,0,'Time automatically deposited into your bank account.. ') ;
      Deposit := TimeRemaining - MaxWinnings ;
      Display(0,15,0,Stri(Deposit,4)) ;
      DepositTime(RatPath,UserName,Deposit) ;
      DecTime(Deposit) ;
      sDisplay(0,14,0,'Your adjusted time limit............................. ') ;
      Display(0,15,0,Stri(TimeRemaining,4)) ;
      CRLF ;
      More('Press [any key] to continue',12) ;
   END ;
   setcolor(0,7,0) ;
   StatusLineOn := FALSE ;
   ClearScreen ;
   LastComments ;
END ;




Procedure Terminate(n:byte) ;
begin
  case n of
    0 : begin
          CloseGame ;
          Comments ;
        end ;
    1 : begin
          Writeln(' Carrier lost') ;
          CloseGame ;
        end ;
    2 : begin
          Writeln(' Time limit exceeded') ;
          CloseGame ;
          LastComments ;
        end ;
    3 : begin
          Writeln(' User inactive') ;
          CloseGame ;
          LastComments ;
        end ;
    4 : begin
           If Not DoorSys then
             Writeln(' Dorinfo'+Node+'.Def file not found')
           else Writeln(' Door.Sys file not found') ;
        end ;
    5 : begin
           Writeln('EXITINFO.BBS or DOOR.SYS file not found') ;
        end ;
    6 : begin
           Writeln(' Directory read/change error') ;
        end ;
    7 : begin
          Writeln(' CTS timeout error') ;
          CloseGame ;
        End ;
    8 : begin  {null exit - like no ansi enabled}
           StatusLineOn := FALSE ;
           LastComments ;
        end ;
    15: begin
        end ;
    else CloseGame ;  { probable runtime error. check Rob.log }
  end ;
end ;

{$I RobExit}

PROCEDURE ClearCards ;
CONST
   RowNumber : ARRAY [1..6] OF BYTE = (8,9,10,13,14,15) ;
VAR
   jj        : BYTE ;
BEGIN
   FOR jj := 1 TO 6 DO
   BEGIN
      CursorPos(RowNumber[jj],16) ;
      sDisplay(0,15,0,#27+'[K') ;
   END ;
END ;


PROCEDURE WriteVersion ;
BEGIN
   CursorPos(5,77) ;
   sDisplay(0,8,0,Version) ;
END ;


PROCEDURE ClearBet ;
BEGIN
   CursorPos(18,26) ;
   sDisplay(0,11,0,MkString(10,' ')) ;
END ;

PROCEDURE WriteBet ;
BEGIN
   ClearBet ;
   CursorPos(18,26) ;
   sDisplay(0,11,0,Center(ItoA(BetAmount),10)) ;
END ;


PROCEDURE ClearBlackScore ;
BEGIN
   CursorPos(9,6) ;
   sDisplay(0,14,0,'  ') ;
END ;

PROCEDURE WriteBlackScore(n : INTEGER) ;
BEGIN
   CursorPos(9,6) ;
   sDisplay(0,14,0,RJust(ItoA(n),2)) ;
END ;


PROCEDURE ClearRedScore ;
BEGIN
   CursorPos(14,6) ;
   sDisplay(0,14,0,'  ') ;
END ;

PROCEDURE WriteRedScore(n : INTEGER) ;
BEGIN
   CursorPos(14,6) ;
   sDisplay(0,14,0,RJust(ItoA(n),2)) ;
END ;


PROCEDURE ClearFirstCard ;
BEGIN
   CursorPos(18,38) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteFirstCard ;
VAR
   Tc    : STRING[1] ;
BEGIN
   CASE ORD(FirstCard.Suit) OF
      0  : Tc := clubchar ;  {clubs}
      1  : Tc := #4 ;        {diamonds}
      2  : Tc := #3 ;        {hearts}
      3  : Tc := #6 ;        {spades}
   END ;
   CursorPos(18,38) ;
   sDisplay(0,11,0,Center(FirstCard.CardNum+Tc,10)) ;
END ;


PROCEDURE ClearResult ;
BEGIN
   CursorPos(21,38) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteResult(tstr:STRING) ; {write color or inverse}
BEGIN
   ClearResult ;
   CursorPos(21,38) ;
   sDisplay(0,11,0,Center(tstr,10)) ;
END ;




PROCEDURE ClearCoinValue ;
BEGIN
   CursorPos(21,2) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteCoinValue ;
BEGIN
   ClearCoinValue ;
   CursorPos(21,2) ;
   sDisplay(0,11,0,Center(ItoA(CoinValue)+' Mins',10)) ;
END ;


PROCEDURE ClearTurnCount ;
BEGIN
   CursorPos(18,2) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteTurnCount ;
BEGIN
   ClearTurnCount ;
   CursorPos(18,2) ;
   sDisplay(0,11,0,Center(ItoA(TurnCount)+' of '+Itoa(MaxTurns),10)) ;
END ;


PROCEDURE ClearCoins ;
BEGIN
   CursorPos(21,14) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteCoins ;
BEGIN
   ClearCoins ;
   CursorPos(21,14) ;
   sDisplay(0,11,0,Center(itoa(coins),10)) ;
END ;


PROCEDURE ClearWonLost ;
BEGIN
   CursorPos(21,26) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteWonLost ;
VAR
   i : INTEGER ;
BEGIN
   ClearWonLost ;
   CursorPos(21,26) ;
   ETime := Coins * CoinValue ;
   STime := StartCoins * CoinValue ;
   i := ETime - STime ;
   if i > 0 then sdisplay(0,11,0,Center('+'+itoa(i),10))
     else sDisplay(0,11,0,Center(itoa(i),10)) ;
END ;


PROCEDURE ClearTime ;
BEGIN
   CursorPos(18,14) ;
   sDisplay(0,11,0,'          ') ;
END ;

PROCEDURE WriteTime ;
BEGIN
   ClearTime ;
   CursorPos(18,14) ;
   sDisplay(0,11,0,Center(ItoA(Coins * CoinValue)+' Mins',10)) ;
   WriteWonLost ;
   WriteCoins ;
   WriteTurnCount ;
   WriteCoinValue ;
END ;


PROCEDURE GoCmd ;
BEGIN
   CursorPos(21,59) ;
END ;


PROCEDURE WriteMsg(instr:STRING) ;
BEGIN
   CursorPos(21,50) ;
   sDisplay(0,12,0,#27+'[K'+instr) ;
END ;


PROCEDURE ClearMenu ;
VAR
   j : BYTE ;
BEGIN
   for j := 17 to 21 do
   begin
      CursorPos(j,50) ;
      sdisplay(0,7,0,#27+'[K') ;
   end ;
END ;

PROCEDURE WriteMenu ;
BEGIN
   CursorPos(17,51) ;
   sDisplay(0,12,0,'P') ;
   sDisplay(0,15,0,'>lay Hand      ') ;
   sDisplay(0,12,0,'H') ;
   sDisplay(0,15,0,'>elp') ;
   CursorPos(18,51) ;
   sDisplay(0,12,0,'L') ;
   sDisplay(0,15,0,'>ast Five      ') ;
   sDisplay(0,12,0,'Q') ;
   sDisplay(0,15,0,'>uit') ;
   CursorPos(21,51) ;
   sDisplay(0,14,0,'Select:  ') ;
   GoCmd ;
END ;




PROCEDURE ShuffleDeck ;
VAR
   loopvar : INTEGER ;
   counter : INTEGER ;
   r       : INTEGER ;
   Success : BOOLEAN ;
   NewDeck : ARRAY [1..312] OF DeckRec ;
BEGIN
   RANDOMIZE ;
   counter := 0 ;
   IF (CardCounter < 212) AND (CardCounter > 0) THEN EXIT ;
   WriteMsg('Shuffling 6 52 card decks') ;
   DELAY(2000) ;
   FOR loopvar := 1 TO 6 DO BEGIN
      INC(counter) ;
      NewDeck[counter].CardNum := 'A' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'A' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'A' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'A' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '2' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '2' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '2' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '2' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '3' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '3' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '3' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '3' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '4' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '4' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '4' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '4' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '5' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '5' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '5' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '5' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '6' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '6' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '6' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '6' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '7' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '7' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '7' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '7' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '8' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '8' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '8' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '8' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '9' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '9' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '9' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '9' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := '10' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := '10' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := '10' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := '10' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'J' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'J' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'J' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'J' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'Q' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'Q' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'Q' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'Q' ;
      NewDeck[counter].Suit := S ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'K' ;
      NewDeck[counter].Suit := C ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'K' ;
      NewDeck[counter].Suit := D ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'K' ;
      NewDeck[counter].Suit := H ;
      INC(counter) ;
      NewDeck[counter].CardNum := 'K' ;
      NewDeck[counter].Suit := S ;
   END ; {6 decks of 52 now in NewDeck}
   Success := FALSE ;
   FOR loopvar := 1 TO 312 DO BEGIN    {shuffle the initialized deck}
      REPEAT
         REPEAT
            r := random(313) ;
         UNTIL (r > 0) AND (r < 313) ;
         IF NewDeck[r].CardNum <> 'U' THEN BEGIN
            CardDeck[loopvar].CardNum := NewDeck[r].CardNum ;
            CardDeck[loopvar].Suit := NewDeck[r].Suit ;
            NewDeck[r].CardNum := 'U' ;
            Success := TRUE ;
         END ELSE Success := FALSE ;
      UNTIL Success ;
   END ;
   DELAY(1000) ;
   CardCounter := 0 ;
END ;


FUNCTION CardVal(instr : STR2) : INTEGER ;
VAR
   TVal   : INTEGER ;
BEGIN
   IF instr = 'A' THEN TVal := 1
   ELSE IF (instr = 'K') OR (instr = 'Q') OR (instr = 'J') THEN TVal := 10
   ELSE TVal := AtoI(instr) ;
   CardVal := TVal ;
   Exit ;
END ;

PROCEDURE GetDiffs ;
BEGIN
   IF BlackScore = 31 THEN BlackDiff := 0
     ELSE BlackDiff := BlackScore - 31 ;
   IF RedScore = 31 THEN RedDiff := 0
     ELSE RedDiff := RedScore - 31 ;
END ;

FUNCTION Half(n:LONGINT) : LONGINT ;
BEGIN
   Half := Trunc((n DIV 2)) ;
   Exit ;
END ;

FUNCTION SpaceStr(instr:STRING) : STRING ;
VAR
   TempStr   : STRING ;
   ii        : INTEGER ;
   n         : INTEGER ;
BEGIN
   TempStr := '' ;
   n := 37 - LENGTH(instr) ;
   FOR ii := 1 TO n DO TempStr := TempStr + ' ' ;
   SpaceStr := TempStr ;
END ;



PROCEDURE DealCards ;
BEGIN
   INC(CardCounter) ;
   FirstCard.CardNum := CardDeck[CardCounter].CardNum ;
   FirstCard.Suit := CardDeck[CardCounter].Suit ;
   WriteFirstCard ;

   WriteMsg('Dealing Black Hand') ;

   BlackScore := 0 ;  BlackCounter := 0 ;
   REPEAT
      INC(BlackCounter) ;
      IF BlackScore = 0 THEN
         DrawCard(CardDeck[CardCounter].CardNum,
                  CardDeck[CardCounter].Suit,
                  BlackRow,CardCol[BlackCounter],7,FALSE)
      ELSE
         DrawCard(CardDeck[CardCounter].CardNum,
                  CardDeck[CardCounter].Suit,
                  BlackRow,CardCol[BlackCounter],7,TRUE) ;
      INC(BlackScore,CardVal(CardDeck[CardCounter].CardNum)) ;
      WriteBlackScore(BlackScore) ;
      INC(CardCounter) ;
      DELAY(DSpeed) ;
   UNTIL BlackScore >= 31 ;

   WriteMsg('Dealing Red Hand') ;

   RedScore := 0 ;  RedCounter := 0 ;
   REPEAT
      INC(RedCounter) ;
      IF RedScore = 0 THEN
         DrawCard(CardDeck[CardCounter].CardNum,
                  CardDeck[CardCounter].Suit,
                  RedRow,CardCol[RedCounter],7,FALSE)
      ELSE
         DrawCard(CardDeck[CardCounter].CardNum,
                  CardDeck[CardCounter].Suit,
                  RedRow,CardCol[RedCounter],7,TRUE) ;
      INC(RedScore,CardVal(CardDeck[CardCounter].CardNum)) ;
      WriteRedScore(RedScore) ;
      INC(CardCounter) ;
      DELAY(DSpeed) ;
   UNTIL RedScore >= 31 ;
   ClearMenu ;
   { check outcome }
   IF (RedScore = 31) AND (BlackScore = 31) THEN BEGIN
      WriteResult('Tie at 31') ;
      WriteMsg('Bank takes half of your bet.') ;
      INC(Coins,Half(BetAmount)) ;
      WriteTime ;
      delay(3000) ;
      ClearMenu ;
      EXIT ;
   END ELSE IF RedScore = BlackScore THEN BEGIN  { tie }
      WriteResult('Tie') ;
      WriteMsg('Tie at '+ ItoA(RedScore)+'-All bets cancelled.') ;
      INC(Coins,BetAmount) ;
      WriteTime ;
      delay(3000) ;
      ClearMenu ;
      EXIT ;
   END ELSE BEGIN
      GetDiffs ;  { get differences and sets blackdiff,reddiff }
      IF RedDiff < BlackDiff THEN BEGIN
         IF (FirstCard.Suit=D) OR (FirstCard.Suit=H) THEN BEGIN
            WriteResult('Color') ;
         END ELSE BEGIN
            WriteResult('Inverse') ;
         END ;
      END ELSE IF BlackDiff < RedDiff THEN BEGIN
         IF (FirstCard.Suit=C) OR (FirstCard.Suit=S) THEN BEGIN
            WriteResult('Color') ;
         END ELSE BEGIN
            WriteResult('Inverse') ;
         END ;
      END ;
      IF BetType IN ['R','B'] THEN BEGIN
         IF RedDiff < BlackDiff THEN BEGIN
            IF BetType = 'R' THEN BEGIN
               IF RedDiff = 0 THEN BEGIN
                  ClearMenu ;
                  CursorPos(18,50) ;
                  sDisplay(0,10,0,'Red wins with 31 on the money') ;
                  WriteMsg('Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
               END ELSE BEGIN
                  WriteMsg('Red wins!  Pay off = 2:1') ;
                  INC(Coins,BetAmount*2) ;
               END ;
               WriteTime ;
            END ELSE BEGIN
               WriteMsg('Red wins.  You lose.') ;
            END ;
         END ELSE IF BlackDiff < RedDiff THEN BEGIN
            IF BetType = 'B' THEN BEGIN
               IF BlackDiff = 0 THEN BEGIN
                  ClearMenu ;
                  CursorPos(18,50) ;
                  sdisplay(0,10,0,'Black wins - 31 on the money') ;
                  WriteMsg('Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
               END ELSE BEGIN
                  WriteMsg('Black wins!  Pay off = 2:1') ;
                  INC(Coins,BetAmount*2) ;
               END ;
               WriteTime ;
            END ELSE BEGIN
               WriteMsg('Black wins.  You lose.') ;
            END ;
         END ;
      END ELSE BEGIN  { player bet C or I }
         IF BetType = 'C' THEN BEGIN
            IF (FirstCard.Suit = C) OR (FirstCard.Suit = S) THEN BEGIN
               IF BlackDiff < RedDiff THEN BEGIN
                  WriteMsg('Color wins!  Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
                  WriteTime ;
                  WriteResult('Color') ;
               END ELSE BEGIN
                  WriteMsg('Inverse wins.  You lose.') ;
               END ;
            END ELSE BEGIN
               IF RedDiff < BlackDiff THEN BEGIN
                  WriteMsg('Color wins!  Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
                  WriteTime ;
                  WriteResult('Color') ;
               END ELSE BEGIN
                  WriteMsg('Inverse wins.  You lose.') ;
               END ;
            END ;
         END ELSE BEGIN
            IF (FirstCard.Suit = C) OR (FirstCard.Suit = S) THEN BEGIN
               IF BlackDiff > RedDiff THEN BEGIN
                  WriteMsg('Inverse wins!  Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
                  WriteTime ;
                  WriteResult('Inverse') ;
               END ELSE BEGIN
                  WriteMsg('Color wins.  You lose.') ;
                  WriteResult('Color') ;
               END ;
            END ELSE BEGIN
               IF RedDiff > BlackDiff THEN BEGIN
                  WriteMsg('Inverse wins!  Pay off = 3:1') ;
                  INC(Coins,BetAmount*3) ;
                  WriteTime ;
                  WriteResult('Inverse') ;
               END ELSE BEGIN
                  WriteMsg('Color wins.  You lose.') ;
                  WriteResult('Color') ;
               END ;
            END ;
         END ;
      END ;
      Delay(3000) ;
      ClearMenu ;
   END ;
END ;



FUNCTION FixStr(n : INTEGER) : STRING ;
VAR
   TVal    : STRING ;
BEGIN
   CASE n OF
      0..9 : TVal := '0' + ItoA(n) ;
      ELSE   TVal := ItoA(n) ;
   END ;
   FixStr := TVal ;
END ;


PROCEDURE GetBetAmount ;
VAR
   TVal         : STRING ;
   mb           : INTEGER ;
BEGIN
   IF MaxBet > Coins THEN mb := Coins ELSE mb := MaxBet ;
   REPEAT
      WriteMsg('How many coins? [1..'+ItoA(mb)+']: ') ;
      TVal := GetInput('',1,Length(ItoA(mb))) ;
      IF TVal = '' THEN BetAmount := 0 ELSE BetAmount := AtoI(TVal) ;
   UNTIL (BetAmount = 0) OR (BetAmount <= mb) ;
   IF BetAmount > 0 THEN BEGIN
      DEC(Coins,BetAmount) ;
      WriteTime ;
      WriteBet ;
   END ELSE BEGIN
      DEC(TurnCount) ;
      WriteTurnCount ;
      ClearMenu ;
   END ;
END ;

PROCEDURE GetBetType ;
VAR
   Choice     : CHAR ;
BEGIN
   ClearMenu ;
   CursorPos(18,50) ;
   sDisplay(0,11,0,'Wagering on: R>ed, B>lack') ;
   CursorPos(19,50) ;
   sDisplay(0,11,0,'C>olor or I>nverse') ;
   WriteMsg('Select: ') ;
   REPEAT
      Choice := UPCASE(GetChar) ;
   UNTIL Choice IN ['R','B','C','I'] ;
   sDisplay(0,14,0,Choice) ;
   ClearMenu ;
   BetType := Choice ;
END ;


PROCEDURE DrawTop ;
BEGIN
   CursorPos(1,1) ;
   display(0,4,0, ' Ŀ                    Ŀ') ;
   display(0,4,0, '                             ') ;
   display(0,12,0,' ĿĿ           Ŀ  ĿĿ ') ;
   display(0,12,0,'                              Ĵ   ') ;
   display(0,15,0,'                   ') ;
   CursorPos(4,20) ;
   sdisplay(0,5,0, 'ķ ķ') ;
   CursorPos(5,20) ;
   sdisplay(0,13,0,'Ľ ') ;
   CursorPos(3,56) ;
   sdisplay(0,9,0,'ķ     ķ') ;
   CursorPos(4,56) ;
   sdisplay(0,9,0,' ķķ   ķ') ;
   CursorPos(5,56) ;
   sdisplay(0,9,0,'  Ľ      ') ;
   WriteVersion ;
END ;


PROCEDURE MenuAgent ;
VAR
   Choice     : CHAR ;
   TVal       : STRING[5] ;
   ii,
   bwc,
   TNum       : INTEGER ;
   LogFile    : TEXT ;
   LogLine    : STRING ;
BEGIN
   REPEAT
      WriteMenu ;
      REPEAT
         Choice := UPCASE(GetChar) ;
      UNTIL Choice IN ['H','P','L','Q'] ;
      sDisplay(0,14,0,Choice) ;
      CASE Choice OF
         'P' : BEGIN
                  IF TurnCount >= MaxTurns THEN BEGIN
                     WriteMsg('Your turn is over for today.') ;
                     JPDelay(2,FALSE,FALSE) ;
                  END ELSE IF Coins < 2 THEN BEGIN
                     WriteMsg('You may not gamble any more. Come back again tomorrow.') ;
                     JPDelay(2,FALSE,FALSE) ;
                  END ELSE BEGIN
                     IF NOT FirstPlay THEN BEGIN
                        ClearBlackScore ;
                        ClearRedScore ;
                        ClearCards ;
                        ClearBet ;
                        ClearFirstCard ;
                        ClearResult ;
                     END ELSE FirstPlay := FALSE ;
                     INC(TurnCount) ;
                     WriteTurnCount ;
                     ShuffleDeck ;
                     GetBetAmount ;
                     IF BetAmount > 0 THEN BEGIN
                        GetBetType ;
                        DealCards ;
                     END ;
                  END ;
               END ;
         'H' : BEGIN
                  ClearScreen ;
                  ScrLen := 23 ;
                  AscFile('Rob.Hlp') ;
                  CRLF ;
                  More('Press [any key] to continue',15) ;
                  ShowFile(15,0,0,'Rob.ANS','') ;
                  WriteVersion ;
                  WriteCoinValue ;
                  WriteTurnCount ;
                  WriteTime ;
                  FirstPlay := TRUE ;
               END ;
         'L' : BEGIN
                  IF (EXIST('ROB.HST')) AND (SizeFile('ROB.HST') > 0) THEN BEGIN
                     ASSIGN(Logfile,'ROB.HST') ;
                     RESET(Logfile) ;
                     {  ClrWindow ; }
                     For ii := 1 to 5 do
                     begin
                        CursorPos(ii,1) ;
                        sdisplay(0,7,0,#27+'[K') ;
                     end ;
                     CursorPos(2,1) ;
                     sDisplay(0,3,0, '  ͸͸͸   ͸    ͸') ;
                     CursorPos(3,1) ;
                     sDisplay(0,11,0,'   ͵͸             վ   ') ;
                     CursorPos(4,1) ;
                     sDisplay(0,15,0,';  ;           ;  ;') ;
                     FOR ii := 1 TO 5 DO BEGIN
                        READLN(Logfile,logline) ;
                        CursorPos(ii,39) ;
                        CASE ii OF
                           1 : bwc := 5 ;
                           2 : bwc := 4 ;
                           3 : bwc := 3 ;
                           4 : bwc := 2 ;
                           5 : bwc := 1 ;
                        END ;
                        IF ODD(ii) THEN
                           sDisplay(3,15,0,' ' + StrC(bwc) + '. ' + logline + SpaceStr(logline))
                        ELSE
                           sDisplay(1,15,0,' ' + StrC(bwc) + '. ' + logline + SpaceStr(logline)) ;
                     END ;
                     CLOSE(Logfile) ;
                     WriteMsg('Press [any key] to continue') ;
                     Holding := GetChar ;
                     for ii := 1 to 5 do begin
                        cursorpos(ii,1) ;
                        sdisplay(0,7,0,#27+'[K') ;
                     end ;
                     DrawTop ;
                     ClearMenu ;
                  END ELSE BEGIN
                     WriteMsg('The log file is empty.') ;
                     Delay(3000) ;
                     ClearMenu ;
                  END ;
               END ;
         'D' : BEGIN
                  WriteMsg('Delay speed ('+ItoA(DSpeed)+'): 50=Fast, 1500=Slow, <ENTER>=No Change [50..1500]: ') ;
                  TVal := GetInput('',1,4) ;
                  TNum := AtoI(TVal) ;
                  IF (TNum > 49) AND (TNum < 1501) THEN DSpeed := TNum ;
                  WriteMsg('Delay speed: ' + ItoA(DSpeed)+'.') ;
                  sDisplay(0,12,0,'  Press <ENTER>') ;
                  Holding := GetChar ;
                  WriteMsg('Enter your selection...') ;
               END ;
      END ;
   UNTIL Choice = 'Q' ;
END ;

PROCEDURE SetClub ;
VAR
   Choice    : CHAR ;
BEGIN
   CRLF ;
   Display(0,7,0,'Some communications programs do not display the CLUB character') ;
   Display(0,7,0,'properly.  If you are using one of these communications programs,') ;
   Display(0,7,0,'the CLUB character will not be visible in the prompt below.  If') ;
   Display(0,7,0,'this is the case, then answer No to the prompt.') ;
   CRLF ;
   sDisplay(0,15,0,'Do you see a CLUB character between the arrows? ') ;
   sDisplay(0,14,0,'> ') ;
   sDisplay(0,12,0,ClubChar) ;
   sDisplay(0,14,0,' <') ;
   sDisplay(0,15,0,' (Y,n): ') ;
   REPEAT
      Choice := UPCASE(GetChar) ;
      IF Choice = #13 THEN Choice := 'Y' ;
   UNTIL Choice IN ['Y','N'] ;
   sDisplay(0,15,0,Choice) ;
   IF Choice = 'N' THEN ClubChar := 'C' ;
END ;


PROCEDURE InitVars ;
BEGIN
   FileMode := 66;
   CheckBreak := TRUE ;
   ProductName := 'Red Or Black ' + Version ;
   CkExitInfo := TRUE ;
   CkMsgs := FALSE ;
   DoorExit := TrapExit ;
   TurnCount := 0 ;
   UserName := '<not yet known>' ;
   AbortGame := FALSE ;
   FirstPlay := TRUE ;
   CardCounter := 0 ;
   DSpeed := 1000 ;
   GameClosed := TRUE ;
END ;


FUNCTION GetUserVals : INTEGER ;
VAR
   j         : BYTE ;
   UserVal1,
   UserVal2  : INTEGER ;
BEGIN
   UserVal1 := 0 ; UserVal2 := 0 ;
   FOR j := 1 TO LENGTH(SysopName) DO BEGIN
      UserVal1 := UserVal1 + ORD(SysopName[j]) ;
   END ;
   FOR j := 1 TO LENGTH(SystemName) DO BEGIN
      UserVal2 := UserVal2 + ORD(SystemName[j]) ;
   END ;
   GetUserVals := UserVal1 + UserVal2 ;
   EXIT ;
END ;


PROCEDURE CheckDates ;
VAR
  JulianRec     : FILE OF JulRecord ;
  Jul           : JulRecord ;
  TempFile      : TEXT ;
  Today         : REAL ;
  ErrFlag       : BOOLEAN ;
BEGIN
  ErrFlag := false ;
  GetDate(yr,mn,dt,dy) ;
  Today := Julian(yr,mn,dt) ;

  ASSIGN(JulianRec,'ROB.DTE') ;
  {$I-} Reset(JulianRec) ; {$I+}
  IF ioresult = 0 THEN BEGIN
    READ(JulianRec,Jul) ;
    ErrFlag := Today <> Jul.LastRecordedDate ;
    CLOSE(JulianRec) ;
  END ELSE ErrFlag := true ;
  IF ErrFlag THEN BEGIN
    Rewrite(JulianRec) ;
    Seek(JulianRec,0) ;
    Jul.LastRecordedDate := Today ;
    WRITE(JulianRec,Jul) ;
    CLOSE(JulianRec) ;
    ASSIGN(TempFile,'ROB.TRN') ;
    IF Exist('ROB.TRN') THEN ERASE(TempFile) ;
  END ;
END ;




BEGIN          (* M A I N *)
   GetDate(yr,mn,dt,dy) ;
   InitVars ;
   GetParms ;
   GetConfig ;
   ShowWindow := true ;
   GetDorInfo('1',InfoPath) ;
   UserName := ChangeCase(UserName) ;
   SysopName := ChangeCase(SysopName) ;
   SystemName := ChangeCase(SystemName) ;
   SysopKey[1] := #0 + #46 ;
   SysopProc[1] := ALT_C ;
   SysopKeysON := TRUE ;
   IF NOT SetFossil THEN BEGIN END ;
   SetColor(0,7,0) ;
   PollTerm ;
   if rip then
   begin
      crlf ;
      sendout('!|1K|*|w0000270O12|10000$COFF$|#|#|#') ;
   end ;
   if ansi < 1 then begin
      crlf ;
      display(0,7,0,'This game requires ANSI emulation.  Continue? (Y,n): ') ;
      repeat
         holding := upcase(getchar) ;
         if holding = #13 then holding := 'Y' ;
      until holding in ['Y','N'] ;
      display(0,15,0,holding) ;
      if holding = 'N' then halt(8) ;
      ansi := 1 ;
   end ;
   IF TimeRemaining < 5 THEN BEGIN
      CRLF ;
      Display(0,15,0,'You do not have enough time left to play Red or Black For Time!') ;
      HALT(8) ;
   END ;

   GameClosed := FALSE ;
   SetClub ;
   StatusLineOn := TRUE ;
   Show_Status ;
   ClearScreen ;
   Crlf ; Crlf ;
   Display(0,15,0,Center('Red Or Black version ' + Version,79)) ;
   Display(0,15,0,Center('Copyright (C) 1993 John Parlin',79)) ;
   Display(0,15,0,Center('All rights reserved',79)) ;
   CRLF ;

   Display(0,13,0,Center('Registered to: '+FormatStr(SysopName),79)) ;
   Display(0,13,0,Center('of '+FormatStr(SystemName),79)) ;
   CRLF ;
   Display(0,15,0,Center('You may play '+ItoA(MaxTurns)+
                  ' hands per day.',79)) ;
   CRLF ;
   Display(0,15,0,Center('Next System Event is in ' +
                          itoa(TimeToEvent) + ' minutes.',79)) ;
   CRLF ;
   sDisplay(0,12,0,Center('Press [any key] to continue',79)) ;
   Holding := GetChar ;

   ClearScreen ;
   ShowFile(15,0,0,'RobOpen','') ;
   SetColor(0,7,0) ;
   sDisplay(0,7,0,' ') ;
   holding := getchar ;
   CheckDates ;
   GetTurns ;
   if odd(timeremaining) then inc(timeremaining) ;
   StartTime := TimeRemaining ;
   Coins := StartTime DIV CoinValue ;
   StartCoins := Coins ;

   ShowFile(15,0,0,'Rob.ANS','') ;
   WriteVersion ;
   WriteTurnCount ;
   WriteCoinValue ;
   WriteTime ;

   MenuAgent ;
   HALT(0) ;
END.

